<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog 1.4.x                                                             |
// +---------------------------------------------------------------------------+
// | userlist2.php                                                             |
// |                                                                           |
// | Userlist2 (ver 1.0)                                                       |
// | Lists only the registered (ACTIVE) users of a Geeklog site.               |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Compiled and modified by:                                                 |
// |                                                                           |
// | Author: Tony Damigo <yosho@otaku-kai.com> April 14th, 2007                |
// |         Based on code taken from Geeklog 1.4.x                            |
// |                                                                           |
// |         My thanks to:                                                     |
// |         Dirk Haun <dirk@haun-online.de> for his original userlist.php     |
// |         which made me dig a little deeper into the GL code.               |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

// Set this to true to get various debug messages from this script
$_USER_VERBOSE = false;

require_once ('lib-common.php');
//require_once ('auth.inc.php');
//require_once ($_CONF['path_system'] . 'lib-user.php');

$display = '';

// Make sure user has access to this page
if (empty ($_USER['username'])) { // prevent anon users from viewing the list {
    $retval .= COM_siteHeader ('menu');

$retval .= COM_startBlock ($LANG04[21], '',
               COM_getBlockTemplate ('_msg_block', 'header'));

 //   $retval .= COM_startBlock($LANG04[21]);
    $retval .= 'Sorry, to view the list of members of this site, you need to be a member yourself.'.
    ' Please register or log in.';
    $retval .= COM_endBlock();
/*
    $retval .= COM_startBlock ($MESSAGE[30], '',
               COM_getBlockTemplate ('_msg_block', 'header'));
    $retval .= $MESSAGE[37];
    $retval .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $retval .= COM_siteFooter ();
    COM_accessLog("User {$_USER['username']} tried to illegally access the user administration screen.");
*/
    echo $retval;
    exit;
}


//******************************************************************************
// if inactive for x months return string colored in red
   $inactive_time="1";
//******************************************************************************


function Last_Visited($test_date, $f_txt, $e_txt) {
global $inactive_time;
/******************************************************************************\
 I found and modified this function to meet my needs. My thanks to the author
 for making it available.
\******************************************************************************/
// This is a simple script to calculate the difference between two dates
// and express it in years, months and days
//
// use as in: "my daughter is 4 years, 2 month and 17 days old" ... :-)
//
// Feel free to use this script for whatever you want
//
// version 0.1 / 2002-10-3
//
// please send comments and feedback to webmaster@lotekk.net
//
// ****************************************************************************

// configure the base date here

//$base_day		= 10;		// no leading "0"
//$base_mon		= 6;		// no leading "0"
//$base_yr		= 2004;		// use 4 digit years!

// get the current date (today) -- change this if you need a fixed date

// month / day / year
global $inactive_time;

$a=explode(",",$test_date);

$base_mon = $a[0];
$base_day = $a[1];
$base_yr  = $a[2];


$current_day		= date ("j");
$current_mon		= date ("n");
$current_yr         = date ("Y");

// and now .... calculate the difference! :-)

// overflow is always caused by max days of $base_mon
// so we need to know how many days $base_mon had
$base_mon_max		= date ("t",mktime (0,0,0,$base_mon,$base_day,$base_yr));

// days left till the end of that month
$base_day_diff 		= $base_mon_max - $base_day;

// month left till end of that year
// substract one to handle overflow correctly
$base_mon_diff 		= 12 - $base_mon - 1;

// start on jan 1st of the next year
$start_day		= 1;
$start_mon		= 1;
$start_yr		= $base_yr + 1;

// difference to that 1st of jan
$day_diff	= ($current_day - $start_day) + 1; 	// add today
$mon_diff	= ($current_mon - $start_mon) + 1;	// add current month
$yr_diff	= ($current_yr - $start_yr);

// and add the rest of $base_yr
$day_diff	= $day_diff + $base_day_diff;
$mon_diff	= $mon_diff + $base_mon_diff;

// handle overflow of days
if ($day_diff >= $base_mon_max)
{
	$day_diff = $day_diff - $base_mon_max;
	$mon_diff = $mon_diff + 1;
}

// handle overflow of years
if ($mon_diff >= 12)
{
	$mon_diff = $mon_diff - 12;
	$yr_diff = $yr_diff + 1;
}

// the results are here:

// $yr_diff  	--> the years between the two dates
// $mon_diff 	--> the month between the two dates
// $day_diff 	--> the days between the two dates

// ****************************************************************************

// simple output of the results
//print "The difference between <b>".$base_yr."-".$base_mon."-".$base_day."</b> ";
//print "and <b>".$current_yr."-".$current_mon."-".$current_day."</b> is:";
//print "<br><br>";

// decide is user is active or not
if ($mon_diff >= $inactive_time) {
   $active="0";
} else {
   $active="1";
}

// this is just to make it look nicer
$years = "years";
$months= "months and ";
$days  = "days";

if ($yr_diff == "1") $years  = "year";
if ($mon_diff == "1") $months= "month and ";
if ($day_diff == "1") $days  = "day";

if (($mon_diff !="0") OR ($day_diff !="0")) $comma=", ";
if ($yr_diff =="0") $comma="";
if (($yr_diff !="0") AND ($day_diff !="0") AND ($mon_diff =="0")) $comma=" and ";

if ($yr_diff == "0"){
  $yr_diff  = "";
  $years    = "";
 }

if ($day_diff == "0") {
 $day_diff  ="";
 $days      ="";
 $months="month";
}

if ($mon_diff == "0") {
  $mon_diff ="";
  $months   = "";
}
if (($day_diff=="") AND ($mon_diff=="") AND ($yr_diff=="")) {
 $e_txt=" today";
}


if ($active =="0") {
     // if inactive for x months return string colored in red
     return '<font color="red">'.$f_txt . $yr_diff." ". $years . $comma . $mon_diff. " ". $months. $day_diff ." ". $days. $e_txt . '</font>';

  } else {
    return $f_txt . $yr_diff." ". $years . $comma . $mon_diff. " ". $months. $day_diff ." ". $days . $e_txt;
  }

}

/**
* Creates a list of data with a menu, search, filter, clickable headers etc.
*
* @param    string  $component      name of the list
* @param    string  $fieldfunction  name of the function that handles special entries
* @param    array   $header_arr     array of header fields with sortables and table fields
* @param    array   $text_arr       array with different text strings
* @param    array   $query_arr      array with sql-options
* @param    array   $menu_arr       menu-entries
* @param    array   $defsort_arr    default sorting values
* @param    string  $filter         additional drop-down filters
* @param    string  $extra          additional values passed to fieldfunction
* @return   string                  HTML output of function
*
*/
function myADMIN_list($component, $fieldfunction, $header_arr, $text_arr,
            $query_arr, $menu_arr, $defsort_arr, $filter = '', $extra = '')
{
    global $_CONF, $_TABLES, $LANG_ADMIN, $LANG_ACCESS, $_IMAGE_TYPE, $MESSAGE;

    $retval = '';

    $filter_str = '';
    $order_sql = '';
    $limit = '';
    $prevorder = "";
    if (isset($_GET['prevorder'])) { # what was the last sorting?
        $prevorder = COM_applyFilter ($_GET['prevorder']);
    }

    $query = "";
    if (isset($_REQUEST['q'])) { # get query (text-search)
        $query = $_REQUEST['q'];
    }

    $query_limit = "";
    if (isset($_REQUEST['query_limit'])) { # get query-limit (list-length)
        $query_limit = COM_applyFilter ($_REQUEST['query_limit'], true);
    }

    $offset = 0;
    if (isset ($_REQUEST['offset'])) { # get offset (where does next page start?)
        $offset = COM_applyFilter ($_REQUEST['offset'], true);
    }
    $curpage = 1;
    $page = "";
    if (isset ($_REQUEST[$component . 'listpage'])) {
        $page = COM_applyFilter ($_GET[$component . 'listpage'], true);
        $curpage = $page;
    }
    if ($curpage <= 0) {
        $curpage = 1; #current page has to be larger 0
    }

    #$unfiltered='';
    #if (!empty($query_arr['unfiltered'])) {
    #    $unfiltered = $query_arr['unfiltered'];
    #}

    $help_url = ""; # do we have a help url for the block-header?
    if (!empty($text_arr['help_url'])) {
        $help_url = $text_arr['help_url'];
    }

    $form_url = ""; # what is the form-url for the search button?
    if (!empty($text_arr['form_url'])) {
        $form_url = $text_arr['form_url'];
    }

    $title = ""; # what is the title of the page?
    if (!empty($text_arr['title'])) {
        $title = $text_arr['title'];
    }

    # get all template fields. Maybe menufields can be only loaded if used?
    $admin_templates = new Template($_CONF['path_layout'] . 'admin/lists');
    $admin_templates->set_file (array ('topmenu' => 'topmenu.thtml',
                                       'list' => 'list.thtml',
                                       'header' => 'header.thtml',
                                       'row' => 'listitem.thtml',
                                       'field' => 'field.thtml',
                                       'menufields' => 'menufields.thtml'
                                      ));
    # inserty some values into the template
    $admin_templates->set_var('site_url', $_CONF['site_url']);
    $admin_templates->set_var('form_url', $form_url);
    $admin_templates->set_var('icon', $text_arr['icon']);
    $admin_templates->set_var('lang_edit', $LANG_ADMIN['edit']);

    # define icon paths. Those will be transmitted to $fieldfunction.
    $icon_arr = array(
        'edit' => '<img src="' . $_CONF['layout_url'] . '/images/edit.'
             . $_IMAGE_TYPE . '" border="0" alt="' . $LANG_ADMIN['edit']
             . '" title="' . $LANG_ADMIN['edit'] . '">',
        'copy' => '<img src="' . $_CONF['layout_url'] . '/images/copy.'
             . $_IMAGE_TYPE . '" border="0" alt="' . $LANG_ADMIN['copy']
             . '" title="' . $LANG_ADMIN['copy'] . '">',
        'list' => '<img src="' . $_CONF['layout_url'] . '/images/list.'
            . $_IMAGE_TYPE . '" border="0" alt="' . $LANG_ACCESS['listthem']
            . '" title="' . $LANG_ACCESS['listthem'] . '">'
    );
    # the user can disable the menu. if used, create it.
    if ($text_arr['has_menu']) {
        for ($i = 0; $i < count($menu_arr); $i++) { # iterate through menu
            $admin_templates->set_var('menu_url', $menu_arr[$i]['url'] );
            $admin_templates->set_var('menu_text', $menu_arr[$i]['text'] );
            if ($i < (count($menu_arr) -1)) {
                $admin_templates->set_var('line', '|' ); # add separator
            }
            $admin_templates->parse('menu_fields', 'menufields', true);
            $admin_templates->clear_var('line'); # clear separator after use
        }
        # add text strings to template
        $admin_templates->set_var('lang_search', $LANG_ADMIN['search']);
        $admin_templates->set_var('lang_submit', $LANG_ADMIN['submit']);
        $admin_templates->set_var('lang_limit_results', $LANG_ADMIN['limit_results']);
        $admin_templates->set_var('lang_instructions', $text_arr['instructions']);
        $admin_templates->set_var('last_query', $query);
        $admin_templates->set_var('filter', $filter);
        $admin_templates->parse('top_menu', 'topmenu', true);
    }

    # since people search with ...* replace with ....% for SQL
    $query = str_replace ('*', '%', $query);
    $sql_query = addslashes ($query); # replace quotes etc for security
    $sql = $query_arr['sql']; # get sql from array that builds data

    $order_var = ""; # number that is displayed in URL
    $order = "";     # field that is used in SQL
    if (!isset($_GET['order'])) {
        $order = $defsort_arr['field'];
    } else {
        $order_var = COM_applyFilter ($_GET['order'], true);
        $order_var_link = "&amp;order=$order_var"; # keep the variable for the google paging
        $order = $header_arr[$order_var]['field'];  # current order field name
    }

    $direction = "";
    if (!isset($_GET['direction'])) { # get direction to sort after
        $direction = $defsort_arr['direction'];
    } else {
        $direction = $_GET['direction'];
    }
    if ($order == $prevorder) { #reverse direction if prev. order was the same
        $direction = ($direction == 'desc') ? 'asc' : 'desc';
    } else {
        $direction = ($direction == 'desc') ? 'desc' : 'asc';
    }

    if ($direction == 'asc') { # assign proper arrow img name dep. on sort order
        $arrow = 'bararrowdown';
    } else {
        $arrow = 'bararrowup';
    }
    # make actual order arrow image
    $img_arrow = '&nbsp;<img src="' . $_CONF['layout_url'] . '/images/' . $arrow
            . '.' . $_IMAGE_TYPE . '" border="0" alt="">';

    if (!empty($order)) { # concat order string
        $order_sql = "ORDER BY $order $direction";
    }

    # HEADER FIELDS array(text, field, sort)
    for ($i=0; $i < count( $header_arr ); $i++) { #iterate through all headers
        $admin_templates->set_var('header_text', $header_arr[$i]['text']); # title
        if ($header_arr[$i]['sort'] != false) { # is this sortable?
            if ($order==$header_arr[$i]['field']) { # is this currently sorted?
                $admin_templates->set_var('img_arrow', $img_arrow);
            }
            # make the mouseover effect is sortable
            $admin_templates->set_var('mouse_over', "OnMouseOver=\"this.style.cursor='pointer';\"");
            $order_var = $i; # assign number to field so we know what to sort
            $onclick="onclick=\"window.location.href='$form_url?" #onclick action
                    ."order=$order_var&amp;prevorder=$order&amp;direction=$direction"
                    ."&amp;" . $component . "listpage=$page"
                    ."&amp;q=$query&amp;query_limit=$query_limit$extra';\"";
            $admin_templates->set_var('on_click', $onclick);
        }
        $admin_templates->parse('header_row', 'header', true);
        $admin_templates->clear_var('img_arrow'); # clear all for next header
        $admin_templates->clear_var('mouse_over');
        $admin_templates->clear_var('on_click');
        $admin_templates->clear_var('arrow');
    }

    $has_extras = '';
    if (isset($text_arr['has_extras'])) { # does this one use extras? (google paging)
        $has_extras = $text_arr['has_extras'];
    }
    if ($has_extras) {
        $limit = 50; # default query limit if not other chosen.
                     # maybe this could be a setting from the list?
        if (!empty($query_limit)) {
            $limit = $query_limit;
        }
        if ($query != '') { # set query into form after search
            $admin_templates->set_var ('query', urlencode($query) );
        } else {
            $admin_templates->set_var ('query', '');
        }
        $admin_templates->set_var ('query_limit', $query_limit);
        # choose proper dropdown field for query limit
        $admin_templates->set_var($limit . '_selected', 'selected="selected"');

        if (!empty($query_arr['default_filter'])){ # add default filter to sql
            $filter_str = " {$query_arr['default_filter']}";
        }
        if (!empty ($query)) { # add query fields with search term
            $filter_str .= " AND (";
            for ($f = 0; $f < count($query_arr['query_fields']); $f++) {
                $filter_str .= $query_arr['query_fields'][$f] . " LIKE '$sql_query'";
                if ($f < (count($query_arr['query_fields']) - 1)) {
                    $filter_str .= " OR ";
                }
            }
            $filter_str .= ")";
        }
        $num_pages = ceil (DB_getItem ($_TABLES[$query_arr['table']], 'count(*)',
                            "1 " . $filter_str) / $limit);
        if ($num_pages < $curpage) { # make sure we dont go beyond possible results
               $curpage = 1;
        }
        $offset = (($curpage - 1) * $limit);
        $limit = "LIMIT $offset,$limit"; # get only current page data
    }

    # SQL
    $sql .= "$filter_str $order_sql $limit;";
    $result = DB_query($sql);
    $nrows = DB_numRows($result);
    $r = 1; # r is the counter for the actual displayed rows for correct coloring
    for ($i = 0; $i < $nrows; $i++) { # now go through actual data
        $A = DB_fetchArray($result);


       // ----------------------------------------------------------------------

       if (mySEC_checkUserStatus($A['uid'])!="3") {
         // bypass any non-approved active user

       } elseif ($A['username']=="Anonymous")     {
         // bypass if Anonymous user

       } else {

       // ----------------------------------------------------------------------

        $this_row = false; # as long as no fields are returned, dont print row
        for ($j = 0; $j < count($header_arr); $j++) {
            $fieldname = $header_arr[$j]['field']; # get field name from headers
            $fieldvalue = '';
            if (!empty($A[$fieldname])) { # is there a field in data like that?
                $fieldvalue = $A[$fieldname]; # yes, get its data
            }
            if (!empty($fieldfunction)) { # do we have a fieldfunction?
                $fieldvalue = $fieldfunction($fieldname, $fieldvalue, $A, $icon_arr);
            } else { # if not just take the value
                $fieldvalue = $fieldvalue;
            }
            if ($fieldvalue !== false) { # return was there, so write line
                $this_row = true;
            } else {
                $fieldvalue = ''; # set field = ''
            }
            $admin_templates->set_var('itemtext', $fieldvalue); # write field
            $admin_templates->parse('item_field', 'field', true);
        }
        if ($this_row) { # there was data in at least one field, so print line
            $r++; # switch to next color
            $admin_templates->set_var('cssid', ($r%2)+1); # make alternating table color
            $admin_templates->parse('item_row', 'row', true); # process the complete row
        }
        $admin_templates->clear_var('item_field'); # clear field

       } // end of my if statement

    }

    if ($nrows==0) { # there is no data. return notification message.
        if (isset($text_arr['no_data'])) {
            $message = $text_arr['no_data']; # there is a user-message
        } else {
            $message = $LANG_ADMIN['no_results']; # take std.
        }
        $admin_templates->set_var('message', $message);
    }

    if ($has_extras) { # now make google-paging
        if (!empty($query)) { # port query to next page
            $base_url = $form_url . '?q=' . urlencode($query) . "&amp;query_limit=$query_limit$order_var_link&amp;direction=$direction";
        } else {
            $base_url = $form_url . "?query_limit=$query_limit$order_var_link&amp;direction=$direction";
        }

        if ($num_pages > 1) { # print actual google-paging
            $admin_templates->set_var('google_paging',COM_printPageNavigation($base_url,$curpage,$num_pages, $component . 'listpage='));
        } else {
            $admin_templates->set_var('google_paging', '');
        }
    }

    $admin_templates->parse('output', 'list');

    # Do the actual output
    $retval .= COM_startBlock ($title, $help_url,
                               COM_getBlockTemplate ('_admin_block', 'header'))
             . $admin_templates->finish($admin_templates->get_var('output'))
             . COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer'));

    return $retval;
}

//---------------------------


function mySEC_checkUserStatus($userid)
{
    global $_TABLES, $_CONF;
    // Check user status
    $status = DB_getItem($_TABLES['users'], 'status', "uid=$userid");
    return $status;
}



function listusers() {
    global $LANG_ADMIN, $_TABLES, $_CONF, $LANG28, $LANG01, $_IMAGE_TYPE;
    require_once( $_CONF['path_system'] . 'lib-admin.php' );
    $display = '';

    if ($_CONF['lastlogin']==true) {
        $login_text = $LANG28[41];
        $login_field = 'lastlogin';
    } else {
        $login_text = $LANG28[40];
        $login_field = 'regdate';
    }

    //'<a href="' . $_CONF['site_url']. '/profiles.php?uid=' . $A['uid'].'">'. $LANG04[81] .'</a>';

    $header_arr = array(      # dislay 'text' and use table field 'field'
                    array('text' => $LANG28[3], 'field' => 'username', 'sort' => true),
                    array('text' => $LANG28[4], 'field' => 'fullname', 'sort' => true),
                    array('text' => $login_text, 'field' => $login_field, 'sort' => true),
                    array('text' => $LANG28[7], 'field' => 'email', 'sort' => true)
    );


    $defsort_arr = array('field' => 'uid',
                         'direction' => 'asc');

    $menu_arr = ''; // deleted this non-esentual array


    $myText='To view a user, click on the username you wish to view. You can do simple searches by entering parts of a username, email address or fullname (e.g. *son* or *.edu) in the form below.';

    $text_arr = array(
                      'has_extras'   => true,
                      'has_menu'     => true,
                      'title'        => $LANG01[17],
                      'instructions' => $myText,
                      'icon'         => $_CONF['layout_url'] . '/images/icons/user.' . $_IMAGE_TYPE,
                      'form_url'     => $_CONF['site_url'] . "/myuser.php",
                      'help_url'     => ''
    );



    if ($_CONF['lastlogin']) {
        $join_userinfo="LEFT JOIN {$_TABLES['userinfo']} ON {$_TABLES['users']}.uid={$_TABLES['userinfo']}.uid ";
        $select_userinfo=",lastlogin ";
    }
    $sql = "SELECT {$_TABLES['users']}.uid,username,fullname,email,photo,regdate$select_userinfo FROM {$_TABLES['users']} $join_userinfo WHERE 1";

    $query_arr = array('table' => 'users',
                       'sql' => $sql,
                       'query_fields' => array('username', 'email', 'fullname'),
                       'default_filter' => "AND {$_TABLES['users']}.uid > 1");


    $display .= myAdmin_list ("user", "myADMIN_getListField_users", $header_arr, $text_arr,
                                $query_arr, $menu_arr, $defsort_arr);

    // removes brackets [] that show in $display
    $rip= str_replace("[","", $display);
    return str_replace("]","", $rip);
}
//------------------------------------------------------------------------------
function myADMIN_getListField_users($fieldname, $fieldvalue, $A, $icon_arr)
{
    global $_CONF, $LANG_ADMIN, $LANG28, $LANG04, $_IMAGE_TYPE;

    $retval = '';

    switch($fieldname) {

        case 'username':
            $photoico = '<img src="' . $_CONF['layout_url']
                      . '/images/smallcamera.' . $_IMAGE_TYPE
                      . '" border="0" alt="">';
            if (!empty($A['photo']))
                 {$photoico = $photoico.'&nbsp;';}
            else
                 {$photoico = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';}
            $retval = $photoico.'<a href="'. $_CONF['site_url']. '/users.php?mode=profile&amp;uid='
                      . $A['uid'].'">' . $fieldvalue.'</a>' ;

            break;
        case "lastlogin":
             if ($fieldvalue < 1) {
                 $retval = '<font color="red">'.$LANG28[36].'</font>';
             } else {
                $retval = Last_Visited(date("m,j,Y",$A['lastlogin']), "Last visited "," ago");
            }

            break;
        case "email":

              // make adjustment to supress actual email address
              $retval='<a href="'. $_CONF['site_url']. '/users.php?mode=profile&amp;uid='
                      . $A['uid'].'">' . $LANG04[81] .'</a>';

              // use this string if you wish to show email address
              // $retval ='<a href="' . $_CONF['site_url'] . '/profiles.php?uid=' . $A['uid'] . '">' '</a>';

            break;

        default:
            $retval = $fieldvalue;
            break;
    }
    return $retval;
}

//------------------------------------------------------------------------------

// MAIN


    $mode = '';
    if (isset ($_REQUEST['mode'])) {
        $mode = $_REQUEST['mode'];
    }

    if (isset ($_REQUEST['order'])) {
        $order =  COM_applyFilter ($_REQUEST['order'],true);
    }

    if (isset ($_GET['direction'])) {
        $direction =  COM_applyFilter ($_GET['direction']);
    }

    $display .= COM_siteHeader ('menu', $LANG28[11]);
    if (isset ($_REQUEST['msg'])) {
        $display .= COM_showMessage (COM_applyFilter ($_REQUEST['msg'], true));
    }
    $display .= listusers();
    $display .= COM_siteFooter();


    echo $display;

?>
